<template>
  <q-page class="flex column">
    <!-- Toolbar -->
    <q-toolbar class="bg-background-primary">
      <div class="q-gutter-x-md">
        <q-btn label="Test Request" color="secondary" @click="testRequest" />
        <q-btn icon="delete" color="negative" @click="deleteTest" />
      </div>

      <q-space />

      <div class="q-gutter-x-md">
        <q-toggle
          v-model="state.showResponse"
          label="Show Response"
        />
        <q-btn label="Help" color="accent" @click="showHelp" />
      </div>
    </q-toolbar>

    <q-toolbar v-if="test.error" class="bg-negative">
      {{ test.error }}
    </q-toolbar>

    <div class="flex row col-grow">
      <!-- Editor -->
      <div class="flex col">
        <div class="flex column col-grow">
          <div class="col col-shrink">
            <q-input label="Test Name" v-model="test.name" standout filled />
            <q-select label="Method" v-model="test.method" :options="SupportedMethods" standout filled />
          </div>
          <div class="col col-grow">
            <div class="monaco-container">
              <vue-monaco-editor
                v-model:value="test.payload"
                theme="vs-dark"
                :options="MONACO_EDITOR_OPTIONS"
                language="json"
                className="monaco"
              />
            </div>
          </div>
        </div>
      </div>

      <!-- Artifact -->
      <div v-if="state.showResponse" class="flex col">
        <div class="flex column col-grow">
          <div class="col col-shrink">
            <q-toolbar class="bg-background-primary">
              <q-btn v-if="test.method === 'bch_signTransaction_V0'" label="Broadcast" color="secondary" @click="broadcast()" />
            </q-toolbar>
          </div>
          <div class="col col-grow">
            <div class="monaco-container">
              <vue-monaco-editor
                :value="test.response"
                theme="vs-dark"
                :options="MONACO_EDITOR_READONLY_OPTIONS"
                language="json"
                className="monaco"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </q-page>
</template>

<script setup lang="ts">
import { onBeforeUnmount, computed, ref } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useQuasar } from 'quasar';

import { app } from '../boot/app.js';

import { SupportedMethods } from 'cashconnect';

import { castDataPayloads, parseExtendedJson } from '../utils/misc.js';

import type { TransactionBroadcast } from '../services/electrum-types.js';

import JSON5 from 'json5'
import { binToHex, stringify, encodeTransactionBCH } from '@bitauth/libauth';

import DocsCompileScript from '../docs/bch_compileScript.html?raw';
import DocsGetBalance from '../docs/bch_getBalance.html?raw';
import DocsGetChangeOutput from '../docs/bch_getChangeOutput.html?raw';
import DocsGetTokens from '../docs/bch_getTokens.html?raw';
import DocsSignTransaction from '../docs/bch_signTransaction.md?raw';

const $q = useQuasar();
const $route = useRoute();
const $router = useRouter();

//-----------------------------------------------------------------------------
// State
//-----------------------------------------------------------------------------

const ACTIVE_TEST = Number($route.params['i']);

const MONACO_EDITOR_OPTIONS = {
  automaticLayout: true,
  formatOnType: true,
  formatOnPaste: true,
  language: 'javascript'
}

const MONACO_EDITOR_READONLY_OPTIONS = {
  ...MONACO_EDITOR_OPTIONS,
  readOnly: true,
}

const state = ref<{
  showResponse: boolean,
}>({
  showResponse: false,
});

const test = computed(() => app.project.value.tests[ACTIVE_TEST]);
const signer = computed(() => app.project.value.signer);

//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

async function testRequest() {
  if(!app.walletConnect.isPaired.value) {
    const namespace = {
      bch: {
        chains: signer.value.chains,
        methods: signer.value.methods,
        events: signer.value.events,
        template: app.project.value.template.template,
        allowedTokens: signer.value.allowedTokens,
      }
    }

    if (!await app.walletConnect.pair(namespace)) {
      return;
    }
  }

  try {
    state.value.showResponse = false;

    let parsed = undefined;

    // If there is a payload...
    if(test.value.payload) {
      // Attempt to parse the payload.
      parsed = JSON5.parse(test.value.payload);

      // Transform the data payloads.
      castDataPayloads(parsed);

      console.log(parsed);
    }

    const response = await app.walletConnect.request(test.value.method, parsed);

    test.value.response = JSON.stringify(JSON.parse(stringify(response)), null, 2);

    state.value.showResponse = true;
  } catch(error: any) {
    console.error(error);

    state.value.showResponse = false;

    $q.notify({
      type: 'negative',
      message: error.message
    })
  }
  console.log('TODO');
}

async function broadcast() {
  const dialog = $q.dialog({ message: 'Broadcasting...', progress: true });

  try {
    // Attempt to parse the extended JSON.
    let parsed = parseExtendedJson(test.value.response);

    if(!Array.isArray(parsed)) {
      parsed = [parsed];
    }

    for(const signTransactionResponse of parsed) {
      // Get the transaction.
      const transaction = signTransactionResponse.transaction;

      // If this payload does not contain a transaction, skip it.
      if(!transaction) {
        continue;
      }

      for(const output of transaction.outputs) {
        if(output.resolvedVariables) {
          delete output.resolvedVariables;
        }
      }

      // Encode the transaction
      const transactionEncoded = encodeTransactionBCH(transaction);

      // Convert the encoded transaction to hex for broadcasting.
      const transactionEncodedHex = binToHex(transactionEncoded);

      // Broadcast the transaction.
      await app.electrum.request<TransactionBroadcast>('blockchain.transaction.broadcast', transactionEncodedHex);
    }

    $q.notify({
      type: 'positive',
      message: 'Transaction(s) broadcast successfully',
    });
  } catch(error: any) {
    console.error(error);

    $q.notify({
      type: 'negative',
      message: error.message
    })
  } finally {
    dialog.hide();
  }
}

function showHelp() {
  switch(test.value.method) {
    case 'bch_compileScript_V0': app.showHelp(DocsCompileScript); break;
    case 'bch_getBalance_V0': app.showHelp(DocsGetBalance); break;
    case 'bch_getChangeOutput_V0': app.showHelp(DocsGetChangeOutput); break;
    case 'bch_getTokens_V0': app.showHelp(DocsGetTokens); break;
    case 'bch_signTransaction_V0': app.showHelp(DocsSignTransaction); break;
    default: $q.notify({ message: `${test.value.method}: Haven't documented this yet, sorry` });
  }
}

function deleteTest() {
  $q.dialog({
    title: 'Confirm',
    message: 'Are you sure you want to delete this test?',
    cancel: true,
    persistent: true
  }).onOk(() => {
    app.project.value.tests.splice(ACTIVE_TEST, 1);

    $router.push('/');
  })
}

//-----------------------------------------------------------------------------
// Initialization/Lifecycle
//-----------------------------------------------------------------------------

if(!test.value) {
  throw new Error('No test at this index');
}

if(test.value.response) {
  state.value.showResponse = true;
}

</script>
